;========================================================
;GENERAL DATA
;========================================================
;(lots of wasted spaced, but the file's not huge anyhow)

StringBuffer:
	times 256   db	    0	  ;storage for EXE name (faster if static)
PathStringSize	    dd	    0

MapsDirBuffer:
	times 256   db	    0
MapsPathSize	    dd	    0

_integer	    dd	    "%i",0	  ;for MSVCRT calls (if present)
_float		    dd	    "%f",0

WindowName	    db	    'Trespasser',0
WindowClassName     db	    'DWI - Trespasser',0

SAVEGAME_STRING     db	    'SAVEGAME.*',0

;========================================================
include 'Errors.inc'
;========================================================

CAnimal_BUF	    dd	    0		  ;holds pointers to all CAnimal objects
CAnimal_BUF_SIZE    dd	    0		  ;size of previous buffer and INDEX buffer
New_CAnimal_BUF     db	    1

CAnimal_Names_INDEX	    dd	    0	  ;list of pointers into next buffer for strings
CAnimal_Names_BUF	    dd	    0
CAnimal_Names_BUF_SIZE	    dd	    0
CAnimal_Initial_Info	    dd	    0

CAnimal_JUMP_Info_BUF	    dd	    0

NewLevel_BOOL		    db	    1

;========================================================
;dino location randomizing values

NULL_STRING		db	"NULL",0
ZERO_STRING		db	"0",0
FLOAT_RETRIEVE_STRING	db	"%f, %f, %f",0
MAIN_SECTION		db	"Instances",0
ENTRIES_STRING		db	"Entries",0
ENTRY_COUNT		db	"NumberOfENTRYSections",0
INSTANCE_STRING 	db	"Instance%u",0
RESERVE_STRING		db	"Reserve%u",0
ENTRY_STRING		db	"ENTRY%u",0
LOCATION_STRING 	db	"Location%u",0
STAYNEARMAX_STRING	db	"ForceStayNearMax",0
STAYNEAROK_STRING	db	"ForceStayNearOK",0
WAKEUP_STRING		db	"ForceWakeUp",0
SLEEP_STRING		db	"ForceSleep",0
NOGETOUT_STRING 	db	"DisableActGetOut",0

;========================================================
;for CANIMAL cheat

canimal_title_base	db	"CAnimal Info (%u instances):",0
canimal_title_size	dd	0
canimal_title:
	times 55	db	0
canimal_base_addr	db	"Base Address: 0x%.8X",0
canimal_pos		db	"Location: %.2f, %.2f, %.2f",0
canimal_health		db	"HitPoints: %.2f",0
canimal_maxhealth	db	"MaxHitPoints: %.2f",0
canimal_bravery 	db	"Bravery: %.5f",0
canimal_jumpinfo	db	"ActJumpNew info: %.2f, %.2f, %u, %u, %u",0

canimal_emos_text_table:
	dd canimal_fear,canimal_love,canimal_anger,canimal_curiosity
	dd canimal_hunger,canimal_thirst,canimal_fatigue,canimal_pain
canimal_emos_text_table_end:

canimal_emos_offsets_table:	   ;offsets from main AI class
	dd 4h,8h,0Ch,10h
	dd 14h,18h,1Ch,20h

canimal_anger		db	"Anger: %.5f",0
canimal_curiosity	db	"Curiosity: %.5f",0
canimal_fatigue 	db	"Fatigue: %.5f",0
canimal_fear		db	"Fear: %.5f",0
canimal_hunger		db	"Hunger: %.5f",0
canimal_love		db	"Love: %.5f",0
canimal_thirst		db	"Thirst: %.5f",0
canimal_pain		db	"Pain: %.5f",0

DisplayDinoInfo_BOOL	db	0
DisplayDino_INDEX	dd	0

ShowDinosOnMap_BOOL		db	0
ShowActiveDinoOnMap_BOOL	db	0

ShowFaceFloats_BOOL		db	0
ShowFaceFloat_STRING		db	"Player face values: %.5f, %.5f, %.5f, %.5f",0
Show_Test_Misc_STRING		db	"Misc. values: %u, %.5f, %.5f",0
Test_Var_MISC			dd	0

;========================================================

MapIndex		    db	    "MapIndex.ini",0

;FLAGS/VALUES
UseMXTBITE		    dd	    0
UseWINDOWED		    dd	    0
UseGRAVITY		    dd	    0
UseDRAWDISTANCE 	    dd	    0
UseTRESSTRDBG		    dd	    0
UseDEMOHACK		    dd	    0
UseNoGetOut		    dd	    0
UseNoStayNear		    dd	    0
UseNoStayAway		    dd	    0
UseSleepWake		    dd	    0
UseDisableSWPDelete	    dd	    0
UseCAnimalHitPoints	    dd	    0
UseRandomDinoLocations	    dd	    0
UseDisableActJumpNew	    dd	    0

UseUserMapKey		    dd	    0
UseUserMDinoKey 	    dd	    0
UseDrawDistSubKey	    dd	    0
UseDrawDistAddKey	    dd	    0
UseCANIMALKey		    dd	    0
UseUserMSelKey		    dd	    0
UseUserCANIMALLEFTKey	    dd	    0
UseUserCANIMALRIGHTKey	    dd	    0
UseMXTRadius		    dd	    0

UseToggleNewKeys	    dd	    0
ToggleNewKeys_BOOL	    db	    1
ToggleKeys_FORCED_BOOL	    db	    0
ToggleKeysShowStateTime     dd	    0

;troubleshooting
UseDisableA3Ddll	    dd	    0
UseHighResolutionsHack	    dd	    0

SDBGDUMPFILE	    db	    "C:\SDBG_DUMP.txt",0

RT_ERROR_COUNT			dd	    0
LAST_ERROR_TIME 		dd	    0
ErrorCountDisplayString 	db	"ATXTres Error Detected (Total: %u)",0

;========================================================
;VARIOUS STORED FLOATS

float_two		dd	2.000000
float_one		dd	1.000000
float_0_5		dd	0.500000
pidivtwo		dd	1.5707963267948966192313216916398
pidiv180		dd	0.0174532925199432957692369076848861
float_100		dd	100.000000

;========================================================
;AT-SPECIFIC VARIABLES

;AT100
LastTimerID	    dd	    0		  ;used to remember last set timer

;AT102
AT102EMULATEDOBJECT:
		    dd	    0
		    dd	    0
		    dd	    0
		    dd	    0
		    dd	    0
		    dd	    0
		    dd	    0
		    dd	    1	;1 for direct BMP name ref (not relative to buffer)

;current bitmap values /*
anchorXvalue	    dd	    0
anchorYvalue	    dd	    0
scaleXvalue	    dd	    0
scaleYvalue	    dd	    0

currentbitmap	    dd	    0
bitmapheight	    dd	    0
bitmapwidth	    dd	    0
;                       */

USE_MAP 	    db	    0
USE_LOC 	    db	    0
LastTickCount	    dd	    0
Show_Blinker	    db	    1

SAVED_MAP_BUFFER:
	times 80 db 0

CURRENT_MAP_BUFFER:
	times 80 db 0
CURRENT_MAP_VALUES:
	times 4 dd 0

SAVEGAMENAME_BUFFER:
	times 256 db 0

SAVED_MAP_OBJECT:
		    dd	    0
		    dd	    0
		    dd	    SAVED_MAP_BUFFER
SAVED_MAP_X1	    dd	    0
SAVED_MAP_Y1	    dd	    0
SAVED_MAP_X2	    dd	    0
SAVED_MAP_Y2	    dd	    0
		    dd	    1		;1 for direct BMP name ref

IsInGame_BOOL			db	0
IsInConsole_BOOL		db	0

DrawDistDisplayTime		dd	0
DrawDistDisplayString		db	"Draw Distance: %2f",0

;========================================================
;counter stuff
CounterFirstRun     dd	    0
USE_COUNTER	    dd	    0
FirstTimeStamp	    dd	    0
Time_Format_String  db	    "Time: %-.2u:%-.2u:%-.2u",0

;========================================================
;MXTBITE

AT100SimulatedObject:
		    dd	    0
		    dd	    0
DefaultSlowSpeed    dd	    0
DefaultInterval     dd	    0
		    dd	    0
		    dd	    0

NormalGameSpeed     dd	    0	 ;updated with variable from executable or INI and/or ActionType 100-101

;========================================================
;DirectDraw-related

Effects_BOOL		dd	0	;bit0 = effect1, bit1 = n/a
Test_Main_BOOL		dd	0

lpDDBltFx		DDBLTFX
;DDSurface_Temp          DDSURFACEDESC2

;========================================================
;HACKED CONSOLE VARIABLES

STRING_LOC		    db	"LOC",0
STRING_DINOS		    db	"DINOS",0
STRING_BIONICWOMAN	    db	"BIONICWOMAN",0
STRING_INVUL		    db	"INVUL",0
STRING_WOO		    db	"WOO",0

Cheattable:
	times (2*80)	dd	0	;extra size for new cheat(s)

STRING_MAP		    db	"MAP",0
STRING_TIME		    db	"TIME",0
STRING_RESET		    db	"RESET",0
STRING_DINOINFO 	    db	"CANIMAL",0
STRING_DINOINFOCYCLELEFT    db	"B",0
STRING_DINOINFOCYCLERIGHT   db	"N",0
STRING_KILLDINO 	    db	"KILL",0
STRING_MDINO		    db	"MDINO",0
STRING_MSEL		    db	"MSEL",0
STRING_HEALDINO 	    db	"HEALDINO",0
STRING_TESTCHEAT	    db	"TEST",0
STRING_CLOAK		    db	"CLOAK",0
STRING_FAC		    db	"FAC",0
STRING_FLY		    db	"FLY",0
STRING_KILLALL		    db	"KILLALL",0
STRING_TELEDINO 	    db	"TELEDINO",0

MACRO DEFINE_CHEAT cheat1 {
      dd cheat1
      dd 0
      }

NewCheattableMembers:
	DEFINE_CHEAT	  STRING_MAP
	DEFINE_CHEAT	  STRING_TIME
	DEFINE_CHEAT	  STRING_RESET
	DEFINE_CHEAT	  STRING_DINOINFO
	DEFINE_CHEAT	  STRING_DINOINFOCYCLELEFT
	DEFINE_CHEAT	  STRING_DINOINFOCYCLERIGHT
	DEFINE_CHEAT	  STRING_KILLDINO
	DEFINE_CHEAT	  STRING_MDINO
	DEFINE_CHEAT	  STRING_MSEL
	DEFINE_CHEAT	  STRING_HEALDINO
	DEFINE_CHEAT	  STRING_TESTCHEAT
	DEFINE_CHEAT	  STRING_CLOAK
	DEFINE_CHEAT	  STRING_FAC
	DEFINE_CHEAT	  STRING_FLY
	DEFINE_CHEAT	  STRING_KILLALL
	DEFINE_CHEAT	  STRING_TELEDINO
EndNewCheattableMembers:

CHEATJUMPINDEX:
	times 80	dd	0

NEWCHEATSINDEX:
	dd	DISPLAYMAPCONSOLE
	dd	DISPLAYCOUNTER
	dd	RESETCOUNTER
	dd	DISPLAYDINOINFO
	dd	CYCLEDINOINFOLEFT
	dd	CYCLEDINOINFORIGHT
	dd	KILLACTIVEDINO
	dd	SHOWDINOSONMAP
	dd	SHOWACTIVEDINOONMAP
	dd	HEALACTIVEDINO
	dd	TESTCHEATCODE
	dd	CHANGEPLAYERTYPE
	dd	SHOWPLAYERFACEFLOATS
	dd	ENABLEFLYCHEAT
	dd	KILLALLDINOS
	dd	TELEPORTDINOCHEAT
ENDNEWCHEATSINDEX:

TotalCheats	dd	0
OriginalCheats	dd	0

;========================================================
;FLY MODE VALUES/VARS

UseFlySpeed		dd	0
UseFlyKeyDelay		dd	0
UseFlyKeyDelay_RECIPR	dd	0

FlySpeedTemp		dd	0
FlySpeedTemp_Fast	dd	0

FLY_MODE_BOOL		db	0
Key_Last_Recorded_Time	dd	0

LastXPostion_FLY	dd	0	;only these need to be updated
LastYPostion_FLY	dd	0	;when cheat is enabled
LastZPostion_FLY	dd	0

Temp_Fly_Buffer:
	times 16 dd 0

Temp_Fly_Buffer2:
	times 8 dd 0

Temp_Fly_Buffer3:
	dd 0
	dd 03F800000h
	dd 0

DefaultKeyBOOLS:	;from "KeyMap" reg key/exe key list
	dd	00000040h
	dd	00000080h
	dd	00000010h
	dd	00000008h
	dd	00000020h
	dd	00000001h
	dd	00000002h
	dd	00000100h
	dd	00000400h
	dd	00000200h
	dd	01000000h
	dd	02000000h
	dd	04000000h
	dd	08000000h
	dd	10000000h
DefaultKeyBOOLS_END:

;========================================================
;DINO JUMP DATA/BUFFERS
;========================================================
AT10_SIM_OBJECT:
	times (64+16) db 0	    ;VTable set in INI init code include file

AT10_EMITTER_SIM_OBJECT:
	times 100 db 0

STRING_GENERAL		db	"General",0
STRING_PUSH		db	"Push",0
STRING_JUMPANGLE	db	"JumpAngle",0
STRING_JUMPTENDANCY	db	"JumpTendancy",0
STRING_REPEATPERIOD	db	"RepeatPeriod",0

;default values
Push_INIdef:
	times 50	db	0
JumpAngle_INIdef:
	times 50	db	0
JumpTendancy_INIdef	dd	0
RepeatPeriod_INIdef	dd	0

;storage default values
Push_default:
	times 50	db	0
JumpAngle_default:
	times 50	db	0
JumpTendancy_default	dd	0
RepeatPeriod_default	dd	0
			;last tick count+last tick count





