;============================================================
;displays current draw distance
;============================================================
DisplayDrawDistance:
cmp [DrawDistDisplayTime],0
    jnz DoDisplayDrawDistance
    ret
DoDisplayDrawDistance:

push ebp
mov ebp,esp
sub esp,100

	mov eax,[BaseDDSurfaceADDR]
	mov ecx,[eax]
	call [EXEPROC_GETDDSURFDC]	;GetDC for DDraw surface via EXE
	mov edi,eax

	lea ebx,[ebp-100]
	sub esp,8
	mov edx,[DrawDistanceVarADDR]
	fld DWORD [edx]
	fstp QWORD [esp]

invoke sprintf,ebx,DrawDistDisplayString
	add esp,16

invoke TextOut,edi,0,SHOW_DRAW_DIST_MSG,ebx,eax

	mov eax,[BaseDDSurfaceADDR]
	push edi		 ;DDraw ReleaseDC
	mov ecx,[eax]
	call [EXEPROC_RELEASEDDSURFDC]

invoke GetTickCount
       sub eax,[DrawDistDisplayTime]
       cmp eax,3000
	   jb NoChangeDrawDistDisplayTime
       and [DrawDistDisplayTime],0
       NoChangeDrawDistDisplayTime:

mov esp,ebp
pop ebp
ret

